#**************************************************************************************
#Copyright (c) 2001 ZeOmega Infotech Pvt Ltd.
# Author:Debojit Hazarika
#**************************************************************************************
"""ZProject object is a project and ressource information based on BITS and ZTIMESHEET """

import Globals
from OFS import SimpleItem, ObjectManager, PropertyManager, FindSupport
import AccessControl.Role, webdav.Collection
from webdav.WriteLockInterface import WriteLockInterface
from AccessControl import Unauthorized
from Globals import HTMLFile
from Globals import DTMLFile
from AccessControl import getSecurityManager
from Globals import Persistent
import Acquisition
from Globals import MessageDialog
import string
from ZtimeEntry import ZtimeEntry, ZtimeEntryDemo, MemberZTimeEntry #new line
#from TimeHelpers import getWeek #new line
from DateTime import DateTime
from SQLHelpers import sqlattr #new line - taken from TimesheetEntry.py
ListType=type([]) #ny linie
from App.ImageFile import ImageFile


manage_addBITSForm=DTMLFile('dtml/BITSAdd', globals())

def manage_addBITS(self, id, title='',createUserF=1,REQUEST=None):
    """Add a new BITS object with id *id*.

    If the 'createUserF' parameters is set to true
    value, a 'UserFolder' objects is created 
    in the new BITS Object.
    """
    if self.meta_type=='ZTIMEPROJECT':
         raise 'ZTIMEPROJECT cannot be added inside ZTIMEPROJECT'
       
    ob=BITS(id,title)
    self._setObject(id, ob)
    ob=self._getOb(id)

    checkPermission=getSecurityManager().checkPermission

    ROLES=['Projectmanager','Teammember','Teamleader','ZMI']
    for role in ROLES:
        self.REQUEST.set('role',role)
        self.manage_defined_roles(submit='Add Role',REQUEST=self.REQUEST)
    
    if createUserF:
        if not checkPermission('Add User Folders', ob):
            raise Unauthorized, (
                  'You are not authorized to add User Folders.'
                  )
        ob.manage_addUserFolder()
    if REQUEST.has_key('goto'):
        return REQUEST['RESPONSE'].redirect(REQUEST['goto'])


class BITS(ObjectManager.ObjectManager,PropertyManager.PropertyManager,AccessControl.Role.RoleManager,webdav.Collection.Collection,SimpleItem.Item,FindSupport.FindSupport,):
    """BITS is a container objects that provide a standard interface for BUGS management."""
    
    __implements__ = (WriteLockInterface,)
    meta_type='ZTIMEPROJECT'
    manage_options=(
        (ObjectManager.ObjectManager.manage_options[0],)+
        (
            {'label':'View', 'action':'index_html',},
            )+AccessControl.Role.RoleManager.manage_options)
    index_html = HTMLFile('dtml/BITS_view',globals())
    BITS_style=HTMLFile('dtml/BITS_style_sheet',globals())
    blank=HTMLFile('dtml/Blank',globals())
    project_html=HTMLFile('dtml/Project_form',globals())
    users_html=HTMLFile('dtml/Users_form',globals())
    option_html=HTMLFile('dtml/Options_form',globals())
    user_list_html=HTMLFile('dtml/User_list_form',globals())
    modify_user_html=HTMLFile('dtml/Modify_user_form',globals())
    modify_project_html=HTMLFile('dtml/Modify_project_form',globals())
    main_header=HTMLFile('dtml/Bits_main_header',globals())
    add_task_html=HTMLFile('dtml/Bits_add_task_form',globals())
    all_task_list_html=HTMLFile('dtml/Bits_all_task_list_form',globals())
    my_task_list_html=HTMLFile('dtml/Bits_my_task_list_form',globals())
    search_task_list_html=HTMLFile('dtml/Bits_search_task_list_form',globals())
    bugs_view=HTMLFile('dtml/BUGS_view',globals())
    bugs_update=HTMLFile('dtml/BUGS_update',globals())
    bugs_log=HTMLFile('dtml/BUGS_log',globals())
    bugs_list=HTMLFile('dtml/BUGS_list',globals())
    ztimesheet_html=DTMLFile('dtml/ztimesheet_html',globals())
    addZtimeEntryForm=DTMLFile('dtml/addZtimeEntryForm',globals())
    test_1_index_html=DTMLFile('dtml/test_1_index_html',globals())
    editWeekForm=DTMLFile('dtml/editWeekForm',globals())
    addCommentForm=DTMLFile('dtml/addCommentForm',globals())
    viewCommentForm=DTMLFile('dtml/viewCommentForm',globals())
    calendar=HTMLFile('calendar/calendar',globals())
    calendar_system=HTMLFile('calendar/calendar-system',globals())
    calendar_en=HTMLFile('calendar/lang/calendar-en',globals())
    calendar_win2k_1=HTMLFile('calendar/calendar-win2k-1',globals())
    bugs_list_gant_1=DTMLFile('dtml/BUGS_list_gant_1',globals())
    management_report=DTMLFile('dtml/management_report',globals())
    bylogo=ImageFile('icons/bylogo.gif',globals())
	
    
    def __init__(self,id,title=''):
        self.id = id
        self.title = title
        self.TASK_STATUS_LIST="['I FORSLAG','STOPPET','AFVENTER','SLUT','I GANG']"
        self.TASK_TYPE_LIST="['MOEDE','HOERING','TALE','PLAN','NOTAT','INDSTILLING']"
        self.PROJECT_LIST=[]
        self.RELATED_SECTOR_LIST="['DIREKTIONEN','BORGMESTEREN','3. KONTOR','BORGER','KOMMUNERNES LANDSFORENING','INTERNT I KONTORET','ANDET']"
        self.MANAGER_PER_PROJECT='{}'
        self.TEAM_PER_PROJECT='{}'
        self.START_DATE_PER_PROJECT='{}'
	self.END_DATE_PER_PROJECT='{}' #new line
	self.ESTIMATED_HOURS_PER_PROJECT='{}'#new line
	self.ZtimeEntries={}
	self.LastEntryID=0
   #Methods to add, edit, delete and retrieve ZtimeEntries
   #gives ability to read entries in the form BITS/1/ where 1 is the id of the ztimesheetentry

    def __getitem__(self,id):
	return self.ZtimeEntries[id].__of__(self)
    def addZtimeEntry(self,USER_ID="",PROJECT_NAME="",hours_date="",comments="",year="",week="",dow="",total_hours="",status="",REQUEST=None):	
    	"method to add an ztimeentry to the Ztimeentries"
	id=self.LastEntryID=self.LastEntryID+1
	id=str(id)
	Ztimeentry=ZtimeEntry(id,USER_ID,PROJECT_NAME,hours_date,comments,year,week,dow,total_hours,status) #class ZtimeEntry from ZtimeEntry.py
	self.ZtimeEntries[id]=Ztimeentry
	self.__changed__(1)
	if REQUEST is not None:
		return self.index_html(self,REQUEST)
    def delZtimeEntries(self,ZtimeEntryIDs=[],REQUEST=None):
	"method to delete ZtimeEntries"
	if type(ZtimeEntryIDs)!=ListType:
		ZtimeEntryIDs=[ZtimeEntryIDs]
	for id in ZtimeEntryIDs:
		try:
			del self.ZtimeEntries[id]
		except KeyError:
			pass

	self.__changed__(1)
	if REQUEST is not None:
 		return self.index_html(self,REQUEST)

#objekts from ZTIMESHEET from here
    def getYearWeek(self, year, week):
	""" Return a list of DateTime objects """
	return self.getWeek(year, week)

    def getTotalHoursForUserForDate(self, date, USER_ID=''):
	""" Get all the hours for a user for a single day 
	Changed to use the object ZtimeEntries in stead of the PostGreSQL"""
	aun = str(USER_ID) #changed, but meaning intact
			
	for entry in self.ZtimeEntries.values():
		if entry.USER_ID==aun and entry.hours_date==date:
			x=x+hours 
	#x = self.sqlGetTotalHoursForUserForDate(member_id=aun,hours_date=date)
	if not x:
		return 0
	if not len(x):
		return 0
	h = x[0]
	hh = sqlattr(h, 'total_hours')
	return hh

	#
	# A week is a list of (7) DateTime objects..
	#
    def isThisWeek(self, week):
	""" Is this week, this week? """
	now = DateTime()
	# day 7 is the start of the day...
	return ( week[0] <= now and now < (week[6]+1))

    def isInThePast(self, week):
	""" Is this week, in the past? """
	now = DateTime()
	return (week[0] < now)

    def isInTheFuture(self, week):
	""" Is this week in the future? """
	now = DateTime()
	# day 7 is the start of the day...
	return (now < (week[6]+1))
	
    


    def getMemberTimesheetEntry(self, year, week, USER_ID=''):
	""" get a timesheet entry (virtual) -erstattes af listMembersZtimeEntries """
	tse=self.GetMemberTimesheetEntries(year=year, week=week,USER_ID=USER_ID)
	if not tse:
		return None
	ts = TimesheetEntry(tse)
	return ts

    def getHoursProject(self,PROJECT_NAME):
	"""method to list hours used for a project"""
	Hours_ZtimeEntries=0
	for Ztimeentry in self.ZtimeEntries.values():
	    if Ztimeentry.PROJECT_NAME==PROJECT_NAME: 
		Hours_ZtimeEntries=Hours_ZtimeEntries+Ztimeentry.total_hours
	return Hours_ZtimeEntries	

#Objects from ZTIMESHEET finito

    def listZtimeEntries(self):
	"method to list ZtimeEntries"
	return self.ZtimeEntries.values()

    def listMembersZtimeEntriesDemo(self,USER_ID,year,week):
	"""method to list entries of af a member in a certain week and year
	See Zopebible p. 250 listEntriesByGroup - o.k.!!!"""
	USER_ID=str(USER_ID) #is needed when USER_ID comes from AUTHENTICATED_USER 
	Member_ZtimeEntries=[]
	for Ztimeentry in self.ZtimeEntries.values():
	    if Ztimeentry.USER_ID==USER_ID and Ztimeentry.year==year and Ztimeentry.week==week:
		Member_ZtimeEntries.append(Ztimeentry)
	return Member_ZtimeEntries	

    def listMembersZtimeProjectEntriesDemo(self,USER_ID,year,week,PROJECT_NAME):
	"""method to list entries of af a member in a certain week, year and project
	See Zopebible p. 250 listEntriesByGroup - o.k.!!!"""
	USER_ID=str(USER_ID) #is needed when USER_ID comes from AUTHENTICATED_USER 
	Member_ZtimeProjectEntries=[]
	for Ztimeentry in self.ZtimeEntries.values():
	    if Ztimeentry.USER_ID==USER_ID and Ztimeentry.year==year and Ztimeentry.week==week and Ztimeentry.PROJECT_NAME==PROJECT_NAME:
		Member_ZtimeProjectEntries.append(Ztimeentry)
	return Member_ZtimeProjectEntries	


    def listMembersZtimeEntriesDemoAll(self,USER_ID):
	"""method to list All entries of af a member
	See Zopebible p. 250 listEntriesByGroup - o.k.!!!"""
	USER_ID=str(USER_ID) #str is needed when USER_ID comes from AUTHENTICATED_USER 
	Member_ZtimeEntriesALL=[]
	for Ztimeentry in self.ZtimeEntries.values():
	    if Ztimeentry.USER_ID==USER_ID:
		Member_ZtimeEntriesALL.append(Ztimeentry)
	return Member_ZtimeEntriesALL	

    def getMemberTimesheetEntryDemo(self, year, week, USER_ID):
	""" get a timesheet entry (virtual) - changed by NSK from ZTimesheet.py
	Used in test_1_index_html.dtml to call existing ZtimeEntries - in ZTimesheet it is a call 	in index_html.dtml, page 1 of getMemberTimesheetEntry in the Ztimesheet.py"""
	aun = str(USER_ID)
	tse=self.listMembersZtimeEntriesDemo(USER_ID=aun,year=year, week=week)
	if not tse:
		return None
	ts = ZtimeEntryDemo(tse)
	return ts

    def getSpecificMemberTimesheetEntry(self,USER_ID,PROJECT_NAME,year,week,dow):
	"""method to get specific entry from timesheet for a member 
	on a specific day"""
	aun=str(USER_ID) #str is needed when USER_ID comes from AUTHENTICATED_USER 
	Member_ZtimeEntriesSpecific=[]
	#for Ztimeentry in self.ZtimeEntries.values():
	#    if (Ztimeentry.USER_ID==aun and Ztimeentry.PROJECT_NAME==PROJECT_NAME and Ztimeentry.year==year and Ztimeentry.week==week and Ztimeentry.dow==dow):
	#	Member_ZtimeEntriesSpecific.append(Ztimeentry)
	return Member_ZtimeEntriesSpecific

    def listHoursMemberProjectWeek(self,USER_ID,PROJECT_NAME,year,week):
	aun=str(USER_ID)
	MembersProjectHoursWeek=0
	for Ztimeentry in self.ZtimeEntries.values():
		if(Ztimeentry.USER_ID==aun and Ztimeentry.PROJECT_NAME==PROJECT_NAME and Ztimeentry.year==year and Ztimeentry.week==week):
			MembersProjectHoursWeek=MembersProjectHoursWeek+Ztimeentry.total_hours
	return int(MembersProjectHoursWeek)
		

	



    def listMembersZtimeEntries(self,year,week,USER_ID):
	"""method to list ZtimeEntries where the user has registrations 
	for a certain week and project - made equivalent to method getAuthorizedProjects"""
	AUTHORIZED_ZtimeEntries=[]
        user_id=str(USER_ID)
        for ZTIME in self.ZtimeEntries.values():
            if USER_ID in self.ZtimeEntries(ZTIME):
                AUTHORIZED_ZtimeEntries.append(ZTIME)
        return AUTHORIZED_ZtimeEntries	
    def getMemberProjectTimesheetEntries(self, year, week, USER_ID):
	""" member entries -taken from ztimesheet.py - same name - called in editWeekForm"""
	mpts=[]
	aun = str(USER_ID)
	mp = self.getAuthorizedProjects(USER_ID)
	for p in mp:
		tse=self.listMembersZtimeProjectEntriesDemo(year=year,week=week,USER_ID=aun,PROJECT_NAME=p)
		if not tse:
			continue
		if not len(tse):
			continue
		ts = MemberZTimeEntry(tse) #changed from former if-statement
		ts.comments=self.getTimesheetComments(year=year, week=week,USER_ID=aun,PROJECT_NAME=p)
		mpts.append(ts)
	return mpts


    def getTimesheetComments(self, year, week,USER_ID, PROJECT_NAME):
	""" returns comments"""
	comments=[]
	for Ztimeentry in self.ZtimeEntries.values():
	    if Ztimeentry.USER_ID==USER_ID and Ztimeentry.year==year and Ztimeentry.week==week and Ztimeentry.PROJECT_NAME==PROJECT_NAME:
		comments.append(Ztimeentry)
	return comments	

	

    def getMembersProjects(self, USER_ID=None):
	""" Get all projects for this member - i not yet in use... """
	if USER_ID is None:
		USER_ID=getSecurityManager().getUser().getUserName()

	#aun = self.getMemberId(member_id)
	aun=str(USER_ID)	
	r = self.GetMembersProjects(member_id=aun)
	if not r:
		return []
	if not len(r):
		return []

	prs=[]
	for p in r:
		pp = self.getProjectFromId(sqlattr(p, 'project_id'))
		prs.append(pp)
	return prs


    # Weeks start on a Monday...(1)
    def getWeek(self, year, weekNumber):
	""" Get a week """

	d = (int(weekNumber)-1) * 7
	x = DateTime(int(year), d)
	dow = x.dow()
	if dow == 0:
		dow = 7

	dayDiff = 7-(dow - 1)

	if dayDiff == 7:
		dayDiff = 0
		
	if dayDiff:
		y = x + float(dayDiff);
	else:
		y = x
	days=[]
	for i in range(7):
		days.append(y)
		y = y + 1.0
	return days

	
    def approveTimesheet(self, year, week, project_id, category_id,
						 member_id, REQUEST={}):
	""" Approve a timesheet """
	self.sqlUpdateTimesheetStatus(member_id=member_id,
									  project_id=project_id,
									  year=year, week=week,
									  category_id=category_id,
									  status=2)
	if REQUEST:
		return self.projectViewForm(self, REQUEST)
	return ''
	
    def updateTimesheetEntry(self, PROJECT_NAME, year, week, dow,
							 hours, status,  comment):
	""" update timesheet  """
	USER_ID=str(getSecurityManager().getUser().getUserName())
	x= self.getSpecificMemberTimesheetEntry(USER_ID=USER_ID,
												   PROJECT_NAME=PROJECT_NAME,
												   year=year, week=week,
												   
												   dow=dow)
	if x and len(x):
		tse = x[0]
		self.sqlUpdateTimesheetEntry(hours_id=sqlattr(tse, 'hours_id'),
										 hours=hours, comments=comment)

		self.sqlUpdateTimesheetStatus(USER_ID=USER_ID,
									  PROJECT_NAME=PROJECT_NAME,
										  year=year, week=week,
										  
										  status=status)
	else:
		#client_id=self.getProjectOwner(project_id)
		w = self.getWeek(year, week)[dow]
		#cl = self.getCategoryFromId(category_id)
		#The folowing line creates the new timesheet-entries in the ZODB
		self.addZtimeEntry(USER_ID=USER_ID,PROJECT_NAME=PROJECT_NAME,		hours_date=w, comments=comment,year=year, week=week, dow=dow,total_hours=hours, status=status)

    def editWeek(self, year, week,REQUEST):
	""" Edit the Week that was """
	status=0
	if REQUEST.has_key('Submit'):
		status=1
	# Iterate over all 20 lines looking for ones that were filled in
	for i in range(1, 21):
		k = 'project_id_%d'%(i)
		#ck= 'category_id_%d'%(i)
		if REQUEST.form[k]:# and REQUEST.form[ck]:
			pid=REQUEST.form[k]
			#cid=REQUEST.form[ck]

			# Now iterate over the days...
			for d in range(7):
				# Add or Update a new timesheet entry 
				self.updateTimesheetEntry(pid, year, week, d,int(REQUEST.form['dow_%d_%d'%(d, i)]), status,REQUEST.form['comment_%d_%d'%(d, i)])
	REQUEST.RESPONSE.redirect('editWeekForm?year=%d&week=%d'%(year,week))

    def execute(self,cmd):
        """executes a string"""
        return eval(cmd)

    def addProject(self):
        """Adds a new project"""
        REQUEST=self.REQUEST
        if str(REQUEST['TEAM_MEMBER'])[0]!='[':
            REQUEST.set('TEAM_MEMBER',[REQUEST['TEAM_MEMBER']])
        PROJECT_NAME=REQUEST['PROJECT_NAME']
        PROJECT_MANAGER=REQUEST['PROJECT_MANAGER']
        TEAM_MEMBER=REQUEST['TEAM_MEMBER']
	ESTIMATED_HOURS=REQUEST['ESTIMATED_HOURS']#new line
	END_DATE=REQUEST['END_DATE']#new line
        if len(string.strip(PROJECT_NAME))<1:
            return REQUEST['RESPONSE'].redirect('project_html?msg=Project name cannot be empty')
        if PROJECT_NAME in self.PROJECT_LIST:
            return REQUEST['RESPONSE'].redirect('project_html?msg=Project name already exist')
        self.PROJECT_LIST.append(PROJECT_NAME)
        self.MANAGER_PER_PROJECT=eval(self.MANAGER_PER_PROJECT)
        self.MANAGER_PER_PROJECT.update({PROJECT_NAME:PROJECT_MANAGER})
        self.MANAGER_PER_PROJECT=str(self.MANAGER_PER_PROJECT)
        self.TEAM_PER_PROJECT=eval(self.TEAM_PER_PROJECT)
        self.TEAM_PER_PROJECT.update({PROJECT_NAME:TEAM_MEMBER})
        self.TEAM_PER_PROJECT=str(self.TEAM_PER_PROJECT)
        self.START_DATE_PER_PROJECT=eval(self.START_DATE_PER_PROJECT)
        self.START_DATE_PER_PROJECT.update({PROJECT_NAME:str(self.ZopeTime())})
        self.START_DATE_PER_PROJECT=str(self.START_DATE_PER_PROJECT)
	self.ESTIMATED_HOURS_PER_PROJECT=eval(self.ESTIMATED_HOURS_PER_PROJECT)#new line
	self.ESTIMATED_HOURS_PER_PROJECT.update({PROJECT_NAME:ESTIMATED_HOURS})#newline
	self.ESTIMATED_HOURS_PER_PROJECT=str(self.ESTIMATED_HOURS_PER_PROJECT)#newline
	self.END_DATE_PER_PROJECT=eval(self.END_DATE_PER_PROJECT)#new line
        self.END_DATE_PER_PROJECT.update({PROJECT_NAME:END_DATE})#new line
	self.END_DATE_PER_PROJECT=str(self.END_DATE_PER_PROJECT)#new line
	return REQUEST['RESPONSE'].redirect('project_html')

    def modifyProject(self):
        """Modify project details"""
        REQUEST=self.REQUEST
        if str(REQUEST['TEAM_MEMBER'])[0]!='[':
            REQUEST.set('TEAM_MEMBER',[REQUEST['TEAM_MEMBER']])
        PROJECT_NAME=REQUEST['PROJECT_NAME']
        OLD_PROJECT_NAME=REQUEST['OLD_PROJECT_NAME']
        PROJECT_MANAGER=REQUEST['PROJECT_MANAGER']
        TEAM_MEMBER=REQUEST['TEAM_MEMBER']
        if len(string.strip(PROJECT_NAME))<1:
            return REQUEST['RESPONSE'].redirect('modify_project_html?msg=Project name cannot be empty')

        self.PROJECT_LIST.remove(OLD_PROJECT_NAME)
        self.PROJECT_LIST.append(PROJECT_NAME)

        MANAGER_LIST=eval(self.MANAGER_PER_PROJECT)
        self.MANAGER_PER_PROJECT={}
        for PROJECT in MANAGER_LIST.keys():
            if PROJECT != OLD_PROJECT_NAME:
                self.MANAGER_PER_PROJECT.update({PROJECT:MANAGER_LIST[PROJECT]})
        self.MANAGER_PER_PROJECT.update({PROJECT_NAME:PROJECT_MANAGER})
        self.MANAGER_PER_PROJECT=str(self.MANAGER_PER_PROJECT)

        TEAM_LIST=eval(self.TEAM_PER_PROJECT)
        self.TEAM_PER_PROJECT={}
        for PROJECT in TEAM_LIST.keys():
            if PROJECT != OLD_PROJECT_NAME:
                self.TEAM_PER_PROJECT.update({PROJECT:TEAM_LIST[PROJECT]})
        self.TEAM_PER_PROJECT.update({PROJECT_NAME:TEAM_MEMBER})
        self.TEAM_PER_PROJECT=str(self.TEAM_PER_PROJECT)

        DATE_LIST=eval(self.START_DATE_PER_PROJECT)
        self.START_DATE_PER_PROJECT={}
        for PROJECT in DATE_LIST.keys():
            if PROJECT != OLD_PROJECT_NAME:
                self.START_DATE_PER_PROJECT.update({PROJECT:DATE_LIST[PROJECT]})
        self.START_DATE_PER_PROJECT.update({PROJECT_NAME:DATE_LIST[OLD_PROJECT_NAME]})
        self.START_DATE_PER_PROJECT=str(self.START_DATE_PER_PROJECT)

        return REQUEST['RESPONSE'].redirect('project_html')

    def deleteProject(self):
        """Deletes a project"""
        REQUEST=self.REQUEST
        PROJECT_ID=REQUEST['PROJECT_ID']
        self.PROJECT_LIST.remove(PROJECT_ID)
        MANAGER_PER_PROJECT=eval(self.MANAGER_PER_PROJECT)
        TEAM_PER_PROJECT=eval(self.TEAM_PER_PROJECT)
        START_DATE_PER_PROJECT=eval(self.START_DATE_PER_PROJECT)
        self.MANAGER_PER_PROJECT={}
        self.TEAM_PER_PROJECT={}
        self.START_DATE_PER_PROJECT={}
        for item in MANAGER_PER_PROJECT.keys():
            if item!=PROJECT_ID:
                self.MANAGER_PER_PROJECT.update({item:MANAGER_PER_PROJECT[item]})
        for item in TEAM_PER_PROJECT.keys():
            if item!=PROJECT_ID:
                self.TEAM_PER_PROJECT.update({item:TEAM_PER_PROJECT[item]})
        for item in START_DATE_PER_PROJECT.keys():
            if item!=PROJECT_ID:
                self.START_DATE_PER_PROJECT.update({item:START_DATE_PER_PROJECT[item]})
        self.MANAGER_PER_PROJECT=str(self.MANAGER_PER_PROJECT)
        self.TEAM_PER_PROJECT=str(self.TEAM_PER_PROJECT)
        self.START_DATE_PER_PROJECT=str(self.START_DATE_PER_PROJECT)
        return REQUEST['RESPONSE'].redirect('project_html')

    def getProjectManager(self,PROJECT_NAME):
        """Returns the project manager for a project"""
        manager_details=eval(self.MANAGER_PER_PROJECT)
        return manager_details[PROJECT_NAME]

    def getEndDate(self,PROJECT_NAME):
        """Returns the end date for a project - NEW"""
        date_details=eval(self.END_DATE_PER_PROJECT)
        return date_details[PROJECT_NAME]

    def getEstimatedHours(self,PROJECT_NAME):
        """Returns estimated hours for a project - NEW"""
        hours_details=eval(self.ESTIMATED_HOURS_PER_PROJECT)
        return hours_details[PROJECT_NAME]


    def getTeamMembers(self,PROJECT_NAME):
        """Returns the team members of a project"""
        team_member_details=eval(self.TEAM_PER_PROJECT)
        return team_member_details[PROJECT_NAME]

    def getStartDate(self,PROJECT_NAME):
        """Returns the project start date"""
        start_date_details=eval(self.START_DATE_PER_PROJECT)
        return start_date_details[PROJECT_NAME]

    def getTASK_TYPE_LIST(self):
        """returns task type list"""
        return eval(self.TASK_TYPE_LIST)

    def deleteTaskType(self):
        """Removes task type from task type list"""
        TASK_TYPE_LIST=self.getTASK_TYPE_LIST()
        REQUEST=self.REQUEST
        if REQUEST.has_key('TASK_TYPE_LIST_TO_DELETE'):
            TASK_TYPE_LIST_TO_DELETE=REQUEST['TASK_TYPE_LIST_TO_DELETE']
        else:
            TASK_TYPE_LIST_TO_DELETE=[]
        if str(TASK_TYPE_LIST_TO_DELETE)[0]!='[':
            TASK_TYPE_LIST_TO_DELETE=[TASK_TYPE_LIST_TO_DELETE]
        for TASK_TYPE in TASK_TYPE_LIST_TO_DELETE:
            TASK_TYPE_LIST.remove(string.upper(TASK_TYPE))
        self.TASK_TYPE_LIST=str(TASK_TYPE_LIST)
        return REQUEST['RESPONSE'].redirect('option_html')

    def addTaskType(self):
        """Adds task type in task type list"""
        TASK_TYPE_LIST=self.getTASK_TYPE_LIST()
        REQUEST=self.REQUEST
        TASK_TYPE=REQUEST['TASK_TYPE']
        if len(string.strip(TASK_TYPE))>0:
            TASK_TYPE_LIST.append(string.upper(TASK_TYPE))
            self.TASK_TYPE_LIST=str(TASK_TYPE_LIST)
        return REQUEST['RESPONSE'].redirect('option_html')

    def getRELATED_SECTOR_LIST(self):
        return eval(self.RELATED_SECTOR_LIST)

    def deleteRelatedSector(self):
        """Removes related sector from related sector list"""
        RELATED_SECTOR_LIST=self.getRELATED_SECTOR_LIST()
        REQUEST=self.REQUEST
        if REQUEST.has_key('RELATED_SECTOR_LIST_TO_DELETE'):
            RELATED_SECTOR_LIST_TO_DELETE=REQUEST['RELATED_SECTOR_LIST_TO_DELETE']
        else:
            RELATED_SECTOR_LIST_TO_DELETE=[]
        if str(RELATED_SECTOR_LIST_TO_DELETE)[0]!='[':
            RELATED_SECTOR_LIST_TO_DELETE=[RELATED_SECTOR_LIST_TO_DELETE]
        for RELATED_SECTOR in RELATED_SECTOR_LIST_TO_DELETE:
            RELATED_SECTOR_LIST.remove(string.upper(RELATED_SECTOR))
        self.RELATED_SECTOR_LIST=str(RELATED_SECTOR_LIST)
        return REQUEST['RESPONSE'].redirect('option_html')

    def addRelatedSector(self):
        """Adds related sector to related sector list"""
        RELATED_SECTOR_LIST=self.getRELATED_SECTOR_LIST()
        REQUEST=self.REQUEST
        RELATED_SECTOR=REQUEST['RELATED_SECTOR']
        if len(string.strip(RELATED_SECTOR))>0:
            RELATED_SECTOR_LIST.append(string.upper(RELATED_SECTOR))
            self.RELATED_SECTOR_LIST=str(RELATED_SECTOR_LIST)
        return REQUEST['RESPONSE'].redirect('option_html')

    def getTASK_STATUS_LIST(self):
        return eval(self.TASK_STATUS_LIST)

    def deleteTaskStatus(self):
        """Removes task status from task status list"""
        TASK_STATUS_LIST=self.getTASK_STATUS_LIST()
        REQUEST=self.REQUEST
        if REQUEST.has_key('TASK_STATUS_LIST_TO_DELETE'):
            TASK_STATUS_LIST_TO_DELETE=REQUEST['TASK_STATUS_LIST_TO_DELETE']
        else:
            TASK_STATUS_LIST_TO_DELETE=[]
        if str(TASK_STATUS_LIST_TO_DELETE)[0]!='[':
            TASK_STATUS_LIST_TO_DELETE=[TASK_STATUS_LIST_TO_DELETE]
        for TASK_STATUS in TASK_STATUS_LIST_TO_DELETE:
            TASK_STATUS_LIST.remove(string.upper(TASK_STATUS))
        self.TASK_STATUS_LIST=str(TASK_STATUS_LIST)
        return REQUEST['RESPONSE'].redirect('option_html')

    def addTaskStatus(self):
        """Adds task status to task status list"""
        TASK_STATUS_LIST=self.getTASK_STATUS_LIST()
        REQUEST=self.REQUEST
        TASK_STATUS=REQUEST['TASK_STATUS']
        if len(string.strip(TASK_STATUS))>0:
            TASK_STATUS_LIST.append(string.upper(TASK_STATUS))
            self.TASK_STATUS_LIST=str(TASK_STATUS_LIST)
        return REQUEST['RESPONSE'].redirect('option_html')

    def addBitsUser(self):
        """Adds users to BITS"""
        REQUEST=self.REQUEST
        USER_ID=string.strip(REQUEST['USER_ID'])
        PASSWORD1=string.strip(REQUEST['PASSWORD1'])
        PASSWORD2=string.strip(REQUEST['PASSWORD2'])
        EXISTING_USERS=REQUEST['EXISTING_USERS']
        if len(EXISTING_USERS)>0:
            if str(EXISTING_USERS)[0]!='[':
                EXISTING_USERS=[EXISTING_USERS]
        else:
            EXISTING_USERS=[]
        ROLES=['Member', 'Authenticated']
        if REQUEST.has_key('USER_ROLES'):
            ROLES.append(REQUEST['USER_ROLES'])
            USER_ROLES=ROLES
            if REQUEST['USER_ROLES'] in ['Projectmanager','Teamleader','Teammember']:
                USER_ROLES.append('Manager')
        else:
            return REQUEST['RESPONSE'].redirect('users_html?msg=User role has to be selected')
        if PASSWORD1!=PASSWORD2:
            return REQUEST['RESPONSE'].redirect('users_html?msg=User cannot be aded as Password does not match')
        if len(USER_ID)<4 or len(PASSWORD1)<4:
            return REQUEST['RESPONSE'].redirect('users_html?msg=User id and password must be greater then 3 character')
        if USER_ID in EXISTING_USERS:
            return REQUEST['RESPONSE'].redirect('users_html?msg=This user id already exist')
        self.acl_users.userFolderAddUser(USER_ID, PASSWORD1,USER_ROLES,'')
        return REQUEST['RESPONSE'].redirect('users_html?msg=User successfully added')

    def deleteBitsUser(self):
        """Deletes Bits users"""
        REQUEST=self.REQUEST
        if REQUEST.has_key('USER_ID_LIST'):
            USER_ID_LIST=REQUEST['USER_ID_LIST']
            if str(USER_ID_LIST)[0]!='[':
                USER_ID_LIST=[USER_ID_LIST]
            self.acl_users.userFolderDelUsers(USER_ID_LIST)
        return REQUEST['RESPONSE'].redirect('users_html')

    def modifyBitsUser(self):
        """Modifies Bits users"""
        REQUEST=self.REQUEST
        USER_ID_LIST=REQUEST['name']
        PASSWORD1=string.strip(REQUEST['password'])
        PASSWORD2=string.strip(REQUEST['confirm'])
        ROLES=['Member', 'Authenticated']
        SELECTED_USER_ROLE=REQUEST['SELECTED_USER_ROLE']
        if REQUEST.has_key('roles'):
            ROLES.append(REQUEST['roles'])
            USER_ROLES=ROLES
            if REQUEST['roles'] in ['Projectmanager','Teamleader','Teammember']:
                USER_ROLES.append('Manager')
            REQUEST.set('roles',USER_ROLES)
        else:
            return REQUEST['RESPONSE'].redirect('modify_user_html?msg=User role has to be selected&SELECTED_USER_ROLE=%s&USER_ID_LIST=%s'%(SELECTED_USER_ROLE,USER_ID_LIST))
        if PASSWORD1!=PASSWORD2:
            if PASSWORD1=='password' and PASSWORD2=='pconfirm':
                x=0
            else:
                return REQUEST['RESPONSE'].redirect('modify_user_html?msg=Password does not match&SELECTED_USER_ROLE=%s&USER_ID_LIST=%s'%(SELECTED_USER_ROLE,USER_ID_LIST))
        if len(PASSWORD1)<4:
            return REQUEST['RESPONSE'].redirect('modify_user_html?msg=Password must be greater then 3 character&SELECTED_USER_ROLE=%s&USER_ID_LIST=%s'%(SELECTED_USER_ROLE,USER_ID_LIST))

        self.acl_users.manage_users(submit='Change',REQUEST=REQUEST)
        return REQUEST['RESPONSE'].redirect('users_html')

    def addBUGS(self,id,title='',FOUND_BY='',ASSIGNED_BY='',ASSIGNED_TO=[],TASK_STATUS='',ESTIMATED_START_DATE='',ESTIMATED_END_DATE='',TASK_TYPE='',PROJECT='',RELATED_SECTOR='',DESCRIPTION=''):
        "Add a BUG"
        REQUEST=self.REQUEST
        if len(string.strip(title))<1:
            return REQUEST['RESPONSE'].redirect('add_task_html?msg=Title cannot be empty')
        if REQUEST is not None:
            creator=REQUEST['AUTHENTICATED_USER']
        if str(ASSIGNED_TO)[0]!='[':
            ASSIGNED_TO=[ASSIGNED_TO]
        ob=BUGS(id,title,FOUND_BY,ASSIGNED_BY,ASSIGNED_TO,TASK_STATUS,ESTIMATED_START_DATE,ESTIMATED_END_DATE,TASK_TYPE,PROJECT,RELATED_SECTOR,DESCRIPTION,creator)
        self._setObject(id, ob)
        ob=self._getOb(id)
        if REQUEST is not None:
            if REQUEST.has_key('goto'):
                return REQUEST['RESPONSE'].redirect(REQUEST['goto'])
            else:
                return self.manage_main(self, REQUEST)
    def deleteBUGS(self):
        """Deletes a bug"""
        REQUEST=self.REQUEST
        if REQUEST.has_key('BUG_ID'):
            self.manage_delObjects([REQUEST['BUG_ID']])
        if REQUEST.has_key('goto'):
            return REQUEST['RESPONSE'].redirect(REQUEST['goto'])
        else:
            return REQUEST['RESPONSE'].redirect('all_task_list_html')

    def getAuthorizedProjects(self,user_id):
        """Returns the project list in which the user is a team member"""
        AUTHORIZED_PROJECTS=[]
        PROJECT_LIST=self.PROJECT_LIST
        if user_id.has_role('Projectmanager') or user_id.has_role('Teamleader') or user_id.has_role('Teammember') : #udmarkeret væk
            return PROJECT_LIST		#udmarkeret væk
        
        for PROJECT in PROJECT_LIST:
            if user_id in self.getTeamMembers(PROJECT):
            	AUTHORIZED_PROJECTS.append(PROJECT)
        return AUTHORIZED_PROJECTS

    def isBugLate(self,BUG_ID):
	"""Returns value 1, if bug i later than ESTIMATED_END_DATE"""
	LateBug=0
	for Bugs in self.objectValues(['BUGS']):
		if Bugs.id==BUG_ID:
			if DateTime()>int(DateTime(Bugs.ESTIMATED_END_DATE[0:10])):
				LateBug=1
	return LateBug




class BUGS (
    SimpleItem.Item,
    Persistent,
    Acquisition.Implicit,
    AccessControl.Role.RoleManager,
    PropertyManager,AccessControl.Unauthorized
    ):
        meta_type="BUGS"
        icon="misc_/BITS/BUGS_icon.gif"

        manage_options = (
            {'label': 'View',	 'action': 'view_bug_html'},
            {'label': 'Edit',	 'action': 'edit_bug_html'},
            )

        view_bug_html = HTMLFile('dtml/BITS_view_bug_form',globals())
        edit_bug_html = HTMLFile('dtml/BITS_edit_bug_form',globals())
        BITS_style=HTMLFile('dtml/BITS_style_sheet',globals())
        configure_header=HTMLFile('dtml/BITS_configure_header',globals())
        blank=HTMLFile('dtml/Blank',globals())

        def __init__(self
                     ,id
                     ,title=''
                     ,FOUND_BY=''
                     ,ASSIGNED_BY=''
                     ,ASSIGNED_TO=[]
                     ,TASK_STATUS=''
                     ,ESTIMATED_START_DATE=''
                     ,ESTIMATED_END_DATE=''
                     ,TASK_TYPE=''
                     ,PROJECT=''
                     ,RELATED_SECTOR=''
                     ,DESCRIPTION=''
                     ,creator=''):
            self.id = id
            self.title = title
            self.creator=creator
            self.FOUND_BY = FOUND_BY
            self.ASSIGNED_BY = ASSIGNED_BY
            self.ASSIGNED_TO = ASSIGNED_TO
            self.TASK_STATUS = TASK_STATUS
            self.ESTIMATED_START_DATE = ESTIMATED_START_DATE
            self.ESTIMATED_END_DATE = ESTIMATED_END_DATE
            self.TASK_TYPE = TASK_TYPE
            self.PROJECT = PROJECT
            self.RELATED_SECTOR = RELATED_SECTOR
            self.DESCRIPTION = DESCRIPTION
            self.LOG_DETAILS=""
            self.NOTES=""

        def editBUG(self):
            """Edits a bug"""
            REQUEST=self.REQUEST
            if not REQUEST.has_key('title'):
                REQUEST.set('title','')
            if not REQUEST.has_key('FOUND_BY'):
                REQUEST.set('FOUND_BY','')
            if not REQUEST.has_key('ASSIGNED_BY'):
                REQUEST.set('ASSIGNED_BY','')
            if not REQUEST.has_key('ASSIGNED_TO'):
                REQUEST.set('ASSIGNED_TO',[])
            if not REQUEST.has_key('TASK_STATUS'):
                REQUEST.set('TASK_STATUS','')
            if not REQUEST.has_key('ESTIMATED_START_DATE'):
                REQUEST.set('ESTIMATED_START_DATE','')
            if not REQUEST.has_key('ESTIMATED_END_DATE'):
                REQUEST.set('ESTIMATED_END_DATE','')
            if not REQUEST.has_key('TASK_TYPE'):
                REQUEST.set('TASK_TYPE','')
            if not REQUEST.has_key('PROJECT'):
                REQUEST.set('PROJECT','')
            if not REQUEST.has_key('RELATED_SECTOR'):
                REQUEST.set('RELATED_SECTOR','')
            if not REQUEST.has_key('DESCRIPTION'):
                REQUEST.set('DESCRIPTION','')

            if str(REQUEST['ASSIGNED_TO'])[0]!='[':
                REQUEST.set('ASSIGNED_TO',[REQUEST['ASSIGNED_TO']])
            self.title=REQUEST['title']
            self.FOUND_BY=REQUEST['FOUND_BY']
            self.ASSIGNED_BY=REQUEST['ASSIGNED_BY']
            self.ASSIGNED_TO=REQUEST['ASSIGNED_TO']
            self.TASK_STATUS=REQUEST['TASK_STATUS']
            self.ESTIMATED_START_DATE=REQUEST['ESTIMATED_START_DATE']
            self.ESTIMATED_END_DATE=REQUEST['ESTIMATED_END_DATE']
            self.TASK_TYPE=REQUEST['TASK_TYPE']
            self.PROJECT=REQUEST['PROJECT']
            self.RELATED_SECTOR=REQUEST['RELATED_SECTOR']
            self.DESCRIPTION=REQUEST['DESCRIPTION']
            self.setLog(REQUEST,'update')
            self.addNotes(REQUEST)
        
            if REQUEST.has_key('goto'):
                return REQUEST['RESPONSE'].redirect(REQUEST['goto'])
            else:
                return REQUEST['RESPONSE'].redirect('view_bug_html')

        def setLog(self,REQUEST,mode):
            if mode=='update':
                initial_text="<table class=border width=100%><tr><td class=client><li>Updated by "+str(REQUEST['AUTHENTICATED_USER'])+" on "+string.split(str(self.ZopeTime()),'.')[0]+"</li></td></tr></table><br>"
            elif mode=='view':
                initial_text="<table class=border width=100%><tr><td class=list_element><li>Viewed by "+str(REQUEST['AUTHENTICATED_USER'])+" on "+string.split(str(self.ZopeTime()),'.')[0]+"</li></td></tr></table><br>"
            self.LOG_DETAILS=self.LOG_DETAILS+initial_text

        def addNotes(self,REQUEST):
            if REQUEST.has_key('NOTES'):
                notes_header="<b><font color=red size=2>By "+str(REQUEST['AUTHENTICATED_USER'])+" on "+string.split(str(self.ZopeTime()),'.')[0]+"</font></b><br>"
                self.NOTES=self.NOTES+notes_header+REQUEST['NOTES']+"<br><br>"


                